#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>
#include "JSSProblem.h"
#include "JSSPReader.h"
#include "JSSPSolution.h"
#include <new.h>

void allocation_handler()
{
   cout << "Out of Memory. Aborting Program...."<< endl;
   exit(1);
}

main(int argc, char *argv[])
{  JSSPReader  JSSReader;
   int i;


   srand(150);
   // Set Allocation Exception Handler

   set_new_handler(allocation_handler);

   printf("\n 1st oparam %s ",argv[0]);
   printf("\n 1nd oparam %s ",argv[1]);
   
   if(argc>1) JSSReader.setFileName(argv[1]); 

   JSSProblem JSSPInstance;
   JSSReader.read(JSSPInstance);
   JSSPInstance.print();

   JSSPSolution sol(JSSPInstance);
   sol.solve();
   //sol.print();
   cout << sol;
   JSSPSolution sol2(JSSPInstance);
   sol2.solveRandom();
   cout << sol2;
   sol2.restore();
   cout << sol2;

   JSSPSolution *Probs =new JSSPSolution[10];

   for(i=0;i<10;i++) Probs[i].setProblem(JSSPInstance);

   for(i=0;i<10;i++) Probs[i].solveRandom();

   for(i=0;i<10;i++) Probs[i].restore();

   int min=0, minval=Probs[min].getMakespan(), next;

   int tot=0;
   for(i=0;i<10;i++)
   {  next = Probs[i].getMakespan();
      tot +=next;
      if(minval>next) { min=i; minval=next;}
   }// end of for

   for(i=0;i<10;i++) cout << "Problem : " << i << endl << Probs[i];

   cout << "The best solution is "<< endl << Probs[min] << endl;


   cout << "PROB#  Makespan" << endl;
   for(i=0;i<10;i++)
       cout << setw(5) << i << setw(10) << Probs[i].getMakespan() << endl;
   cout << endl << "The Population average is " << tot*0.1 << endl;
   cout << "after the print " << endl;

}// end of main()

